
import CompuCellSetup

from PySteppables import *
import CompuCell
import sys

from random import random

class CellsortPythonSteppable(SteppableBasePy):    

    def __init__(self,_simulator,_frequency=10):
        SteppableBasePy.__init__(self,_simulator,_frequency)
        
    def start(self):
        
        for cell in self.cellList:
            cell.targetVolume=25
            cell.lambdaVolume=2.2
            
            # access/modification of a dictionary attached to cell - make sure to decalare in main script that you will use such attribute
            dict_attrib=CompuCell.getPyAttrib(cell)
            dict_attrib["NOD"]=0
            
            
        
    def step(self,mcs):        
        
        field=CompuCell.getConcentrationField(self.simulator,"FGF")
        pt=CompuCell.Point3D()
        pt.x=100 ; pt.y=100 ; pt.z=0
        
        for cell in self.cellList:
            
            dict_attrib=CompuCell.getPyAttrib(cell)



            if cell.type==self.NONCONDENSING:
                
                pt.x=int(cell.xCOM)
                pt.y=int(cell.yCOM)
                pt.z=int(cell.zCOM)
            
                conc=field.get(pt)
                    
                cell.targetVolume+=0.1*conc
                        
        
from PySteppables import *
from PySteppablesExamples import MitosisSteppableBase
import CompuCell
import sys

from PlayerPython import *
from math import *


class MitosisSteppable(MitosisSteppableBase):
    def __init__(self,_simulator,_frequency=1):
        MitosisSteppableBase.__init__(self,_simulator, _frequency)
        
        self.mcs=0
        
        self.scalarCLField=CompuCellSetup.createScalarFieldCellLevelPy("NOD")
        
        
    def step(self,mcs):
        # print "INSIDE MitosisSteppable"
        self.mcs=mcs
        cells_to_divide=[]
        
        clearScalarValueCellLevel(self.scalarCLField)
        
        for cell in self.cellList:
            
            dict_attrib=CompuCell.getPyAttrib(cell)
            print 'id=',cell.id,' NOD=',dict_attrib["NOD"]
            
            fillScalarValueCellLevel(self.scalarCLField,cell,dict_attrib["NOD"])
            
            
            
            if cell.volume>50:
                if cell.type==self.NONCONDENSING:
                    cells_to_divide.append(cell)
                
        for cell in cells_to_divide:
            # to change mitosis mode leave one of the below lines uncommented
            self.divideCellRandomOrientation(cell)
            # self.divideCellOrientationVectorBased(cell,1,0,0)                 # this is a valid option
            # self.divideCellAlongMajorAxis(cell)                               # this is a valid option
            # self.divideCellAlongMinorAxis(cell)                               # this is a valid option

    def updateAttributes(self):
        parentCell=self.mitosisSteppable.parentCell
        childCell=self.mitosisSteppable.childCell
        
        parentCell.targetVolume/=2.0
        childCell.targetVolume=parentCell.targetVolume
        childCell.lambdaVolume=parentCell.lambdaVolume
        
                
        childCell.type=self.CONDENSINGDIFF
        childCell.type=3    
        
        childCell.lambdaVecX=-5.0
        
        child_dict_attrib=CompuCell.getPyAttrib(childCell) 
        child_dict_attrib['NOD']=0
        
        parent_dict_attrib=CompuCell.getPyAttrib(parentCell)        
        parent_dict_attrib["NOD"]+=1
        
        

